package com.mybiz.searchapp;

import java.io.PrintWriter;
import javax.servlet.*;
import javax.servlet.http.*;
import com.mybiz.searchapp.SearchResultsBean;

public class SearchController extends HttpServlet {

  public SearchController() {
    theSearchEngine = new SearchEngine();
  }


  public void doSearch(String name) {
    results = theSearchEngine.find(name);
  }

  protected void doGet(
    javax.servlet.http.HttpServletRequest httpRequest,
    javax.servlet.http.HttpServletResponse httpResponse) {
    doPost(httpRequest, httpResponse); // Allow searches via GET or POST
  }


  protected void doPost(
    javax.servlet.http.HttpServletRequest httpRequest,
    javax.servlet.http.HttpServletResponse httpResponse) {
    String name = httpRequest.getParameter("keyword");
    if ((name != null) && (name.length() > 0)) {
      results = theSearchEngine.find(name);
    } else {
      results = new SearchResultsBean();
    }
    httpRequest.setAttribute("searchResults", results);
    try {
      getServletContext().getRequestDispatcher(resultsPage).forward(
        httpRequest,
        httpResponse);
    } catch (Exception e) {
      httpResponse.setContentType("text/html");
      try {
        PrintWriter out = httpResponse.getWriter();
        out.println("<html>\n");
        out.println("<head><title>Error</title></head>\n");
        out.println("<body>\n");
        out.println("<p>Unable to forward to " + resultsPage + "\n");
        out.println("</body>\n");
        out.println("</html>\n");
      } catch (Exception e2) {
        System.out.println("Unrecoverable error.");
      }
    }
  }

  private SearchResultsBean results;

  private SearchEngine theSearchEngine = null;

  private static final String resultsPage = "/ResultsView.jsp";
}