package com.mybiz.searchapp;

import java.util.Map;
import java.util.HashMap;
import java.util.Stack;
import com.mybiz.searchapp.SearchResultsBean;

public class SearchEngine {

  SearchEngine() {
    resultsMap = new HashMap();
    setupSearch();
  }

  public SearchResultsBean find(String name) {
    doQuery(name);
    return results;
  }

  private final void doQuery(String name) {
    results = new SearchResultsBean();
    Stack queryResults = (Stack) resultsMap.get(name);

    if (queryResults != null) {
      for (int i = 0; i < queryResults.size(); i++) {
        results.setResult((String) queryResults.get(i));
      }
    }
  }

  private void setupSearch() {
    addEntries(resultsMap, 1, 4);
    addEntries(resultsMap, 2, 2);
    addEntries(resultsMap, 3, 5);
    addEntries(resultsMap, 4, 2);
    addEntries(resultsMap, 5, 1);
  }

  private void addEntries(Map map, int keywordSuffix, int resultCount) {
    Stack container = new Stack();
    for (int i = 0; i < resultCount; i++) {
      String entry = "result " + resultsCount;
      container.add(entry);
      resultsCount++;
    }
    String keyword = "keyword" + keywordSuffix;
    map.put(keyword, container);
  }

  private SearchResultsBean results;
  private Map resultsMap;
  private int resultsCount = 1;

}